skip to navigation
skip to content

pyexcel-cli 0.0.2

A command utility to read and write data in csv, tsv, xls, xlsx and ods format.

Known constraints

Fonts, colors and charts are not supported.

pyexcel-cli brings pyexcel to make it easy to consume/produce information stored in excel files on command line interface. This library can turn the excel data into a list of lists, a list of records(dictionaries), dictionaries of lists. And vice versa. Hence it lets you focus on data in shell programming, instead of file formats.

Hightlighted features:

  1. View data in the excel files without Microsoft Office or Open Office
  2. Transcode data among supported excel file formats
  3. Merge files in various excel file formats into one
  4. Split a multi-sheet excel file into single sheet files
  5. Find difference in data between two excel files

Usage

Here is an example usage:

$ pyexcel view https://github.com/pyexcel/pyexcel-cli/blob/master/tests/fixtures/multiple-sheets.xls
Sheet 1:
+---+---+---+
| 1 | 2 | 3 |
+---+---+---+
| 4 | 5 | 6 |
+---+---+---+
| 7 | 8 | 9 |
+---+---+---+
Sheet 2:
+---+---+---+
| X | Y | Z |
+---+---+---+
| 1 | 2 | 3 |
+---+---+---+
| 4 | 5 | 6 |
+---+---+---+
Sheet 3:
+---+---+---+
| O | P | Q |
+---+---+---+
| 3 | 2 | 1 |
+---+---+---+
| 4 | 3 | 2 |
+---+---+---+

Because pyexcel family is loosely coupled, especially for file format supports, you install the libraries that you need to. If you need to support xls format, you will need to install pyexcel-xls. For more information, please see the plugin section. .. _file-format-list: .. _a-map-of-plugins-and-file-formats:

<caption>A list of file formats supported by external plugins</caption>
Package name Supported file formats Dependencies Python versions
pyexcel-io csv, csvz [2], tsv, tsvz [3]   2.6, 2.7, 3.3, 3.4, 3.5, 3.6 pypy
pyexcel-xls xls, xlsx(read only), xlsm(read only) xlrd, xlwt same as above
pyexcel-xlsx xlsx openpyxl same as above
pyexcel-xlsxw xlsx(write only) XlsxWriter same as above
pyexcel-ods3 ods ezodf, lxml 2.6, 2.7, 3.3, 3.4 3.5, 3.6
pyexcel-ods ods odfpy same as above
pyexcel-odsr ods(read only) lxml same as above
pyexcel-text (write only)json, rst, mediawiki, html, latex, grid, pipe, orgtbl, plain simple tabulate 2.6, 2.7, 3.3, 3.4 3.5, pypy, pypy3
pyexcel-handsontable handsontable in html handsontable same as above [1]
pyexcel-pygal svg chart pygal same as above [1]
[1](1, 2) coming soon

In order to manage the list of plugins installed, you need to use pip to add or remove a plugin. When you use virtualenv, you can have different plugins per virtual environment. In the situation where you have multiple plugins that does the same thing in your environment, you need to tell pyexcel which plugin to use per function call. For example, pyexcel-ods and pyexcel-odsr, and you want to get_array to use pyexcel-odsr. You need to append get_array(…, library=’pyexcel-odsr’).

Footnotes

[2]zipped csv file
[3]zipped tsv file

Installation

You can install it via pip:

$ pip install pyexcel-cli

or clone it and install it:

$ git clone https://github.com/pyexcel/pyexcel-cli.git
$ cd pyexcel-cli
$ python setup.py install

Support the project

If your company has embedded pyexcel and its components into a revenue generating product, please support me on patreon to maintain the project and develop it further.

If you are an individual, you are welcome to support me too on patreon and for however long you feel like to. As a patreon, you will receive early access to pyexcel related contents.

With your financial support, I will be able to invest a little bit more time in coding, documentation and writing interesting posts.

Development guide

Development steps for code changes

  1. git clone https://github.com/pyexcel/pyexcel-cli.git
  2. cd pyexcel-cli

Upgrade your setup tools and pip. They are needed for development and testing only:

  1. pip install –upgrade setuptools pip

Then install relevant development requirements:

  1. pip install -r rnd_requirements.txt # if such a file exists
  2. pip install -r requirements.txt
  3. pip install -r tests/requirements.txt

In order to update test environment, and documentation, additional steps are required:

  1. pip install moban
  2. git clone https://github.com/pyexcel/pyexcel-commons.git commons
  3. make your changes in .moban.d directory, then issue command moban

What is rnd_requirements.txt

Usually, it is created when a dependent library is not released. Once the dependecy is installed(will be released), the future version of the dependency in the requirements.txt will be valid.

What is pyexcel-commons

Many information that are shared across pyexcel projects, such as: this developer guide, license info, etc. are stored in pyexcel-commons project.

What is .moban.d

.moban.d stores the specific meta data for the library.

How to test your contribution

Although nose and doctest are both used in code testing, it is adviable that unit tests are put in tests. doctest is incorporated only to make sure the code examples in documentation remain valid across different development releases.

On Linux/Unix systems, please launch your tests like this:

$ make

On Windows systems, please issue this command:

> test.bat

License

New BSD License

Change log

0.0.2 - 19.06.2016

Updated

# use pyexcel v0.5.0

0.0.1 - 11.07.2016

Initial release

 
File Type Py Version Uploaded on Size
pyexcel-cli-0.0.2.tar.gz (md5) Source 2017-06-19 11KB
pyexcel_cli-0.0.2-py2-none-any.whl (md5) Python Wheel 2.7 2017-06-19 14KB